#include <stdio.h>
#include <assert.h>

#include "dbtoc.h"

DbToc::DbToc( char *FName)
{
int     Ret= sqlite3_open( FName, &SqlDb);

if( Ret)
{       fprintf( stderr,"Can't open database (%s): %s\n", FName, sqlite3_errmsg( SqlDb));
        sqlite3_close( SqlDb);
        throw;
}
//Sql("PRAGMA encoding=\"UTF-16\"");
Sql("DROP TABLE source_info");
Sql("CREATE TABLE source_info (name TEXT, value TEXT)");
Sql("DROP TABLE songs");
Sql("CREATE TABLE songs (id INTEGER UNIQUE, title TEXT, artist TEXT, lang_code INTEGER, addr INTEGER)");

//InsertSong( 897,"\215\121\0","11223344\0",0,0);
//assert(0);
}
//---------------------------------------------------------------------------
bool DbToc::Sql( char *Cmd)
{
char *ErrMsg= 0;
int     Ret= sqlite3_exec( SqlDb, Cmd, NULL, 0, &ErrMsg);

if( Ret!= SQLITE_OK)
{       fprintf( stderr,"SQL: %s\n", Cmd);
        fprintf( stderr,"Error: %s\n", ErrMsg);
        sqlite3_free( ErrMsg);
        return false;
}
return true;
}
//---------------------------------------------------------------------------
int     DbToc::InsertSong( int Id, char *Title, char *Artist, int LangCode, int Addr)
{
int     LenT= 0,LenA= 0, Ret;
//int     Ret;
char    Cmd[256];
sqlite3_stmt    *Stmt;

sprintf( Cmd,"INSERT INTO songs( title, artist, id, lang_code, addr) VALUES( ?, ?, %d,%d,%d)",
        Id, LangCode, Addr);

while( Title[ LenT] || Title[ LenT+1])
        LenT+= 2;
while( Artist[ LenA] || Artist[ LenA+1])
        LenA+= 2;
//fprintf( stderr,"%d %d\n", LenT, LenA);

Ret= sqlite3_prepare( SqlDb, Cmd, -1, &Stmt, 0);
if( Ret!=SQLITE_OK )
        return Ret;

printf("%d\n", Id);
//sqlite3_bind_text16( Stmt, 1, Title, -1, SQLITE_STATIC);
//sqlite3_bind_text16( Stmt, 2, Artist, -1, SQLITE_STATIC);
sqlite3_bind_blob( Stmt, 1, Title, LenT+2, SQLITE_STATIC);
sqlite3_bind_blob( Stmt, 2, Artist, LenA+2, SQLITE_STATIC);
Ret= sqlite3_step( Stmt);
assert( Ret!=SQLITE_ROW );

return sqlite3_finalize( Stmt);
}

