/***************************************************************************/
//---------------------------------------------------------------------------
// 22/07/07     First version able to convert midi including lyrics
// Author: Phuoc Can HUA (07/07/07)
/***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string>
#include <vcl.h>

#include "hd00Midi.h"
#include "hd00Contents.h"
#include "gbk2uni.h"

std::string     HeadStr[3];

//---------------------------------------------------------------------------
int CompEvents( const void * Item0, const void * Item1)
{
int     Ret=((SeriEvtType*)Item0)->Time-((SeriEvtType*)Item1)->Time;
if( Ret)
        return Ret;
else
//        return((SeriEvtType*)Item1)->Velo-((SeriEvtType*)Item0)->Velo;
        return((SeriEvtType*)Item0)->Order-((SeriEvtType*)Item1)->Order;
}
//--------------------------------------------------------------------------
void	ReadMidiDat(FILE *InFile, int Offset, FILE *OutFile, int Length, FILE *lFile, int Language)
{
unsigned char    C0,C1,C2,C3,C4;
int     I,J, T, //TrkLen= 0,
        CurAddr, TrkAddr, TrkCnt, Cnt= 0, Time= 0;//[16];
 FILE    /* *InFile, */ *LogFile;
SeriEvtType     *EvtSerie= new SeriEvtType[ 3*Length];
char    CodeUnicode[]= LYR_UNICODE;

#ifdef LOGFILE
LogFile= fopen( LOGFILE, "w");
#endif
fseek( InFile, Offset , SEEK_SET);
for( I= 0; I<Length; I++ )
{       C0= (unsigned char)getc( InFile);
        C1= (unsigned char)getc( InFile);
        C2= (unsigned char)getc( InFile);
        C3= (unsigned char)getc( InFile);
        C4= (unsigned char)getc( InFile);
        if( !(C2& 0x80) && C2 > 0x0f)
        {       printf("%02x %02x *%02x* %02x %02x  Unknown\n", C0, C1, C2, C3, C4);
#ifdef LOGFILE
                fprintf( LogFile,"%02x %02x *%02x* %02x %02x  Unknown\n", C0, C1, C2, C3, C4);
#endif
                continue;
        }
//printf("1\n");

        Time+= C0;
#ifdef LOGFILE
	fprintf( LogFile,"%04x  %02x %02x[%02x]%02x %02x\n", Time, C0, C1, C2, C3, C4);
#endif
//        Cnt= TrkLen;
        EvtSerie[Cnt].Time= Time;//[Trk];
        EvtSerie[Cnt].Chn= C2;
        EvtSerie[Cnt].Note= C3;
        EvtSerie[Cnt].Velo= C4;
        EvtSerie[Cnt].Lyr[0]= EvtSerie[Cnt].Lyr[1]= 0;
        if( !(C2& 0x80))   // Play note
        {       EvtSerie[Cnt].Chn|= 0x90;
                ++Cnt;
//                Time+= C1;
                EvtSerie[Cnt].Time= Time +C1;//;
                EvtSerie[Cnt].Chn= (0x90|C2);
                EvtSerie[Cnt].Note= C3;
                EvtSerie[Cnt].Velo= 0;
                EvtSerie[Cnt].Lyr[0]= EvtSerie[Cnt].Lyr[1]= 0;
        }
        ++Cnt;
//        TrkLen= Cnt;
}
//---- Read lyrics from LPD-file ----
T= 0;
int Ret= fread( EvtSerie[Cnt].Lyr,1,2, lFile);
while( Ret)
{       EvtSerie[Cnt].Chn= EvtSerie[Cnt].Note= 0;
        EvtSerie[Cnt].Time= 0;
        fread( &EvtSerie[Cnt].Time,1,2, lFile);
//        EvtSerie[Cnt].Time+= 14;        // Value to sync lyric with melody
        if( EvtSerie[Cnt].Time > T)
                EvtSerie[Cnt].Order= 0;
        else
        {       EvtSerie[Cnt].Time= T;
                EvtSerie[Cnt].Order= EvtSerie[Cnt-1].Order +1;
        }
        T= EvtSerie[Cnt].Time;
        Ret= fread( EvtSerie[++Cnt].Lyr,1,2, lFile);
}

qsort((void *)EvtSerie, --Cnt, sizeof(SeriEvtType), CompEvents);
printf("sorted\n");

#ifdef LOGFILE
fprintf( LogFile,"\n==== Write MIDI ====\n");
#endif
//---- Write MIDI file ----
char    Header[]={ 0,0,0,6,0,0,
        0,1,    // Tracks
        0x00, 0x1f // Division (high value= faster)
        };
fprintf( OutFile,"MThd");
fwrite( Header, 1, sizeof(Header), OutFile);

SeriEvtType     *Evt;
fprintf( OutFile,"MTrk");
TrkAddr= ftell( OutFile);
fprintf( OutFile,"????");
T= TrkCnt= 0;
if( Language== LNG_CHINESE)
{       fprintf( OutFile,"%c%c%c%c", 0x00, 0xff,0x01, 2*strlen( CodeUnicode));
        for( I= 0; I < strlen( CodeUnicode); I++)
                fprintf( OutFile,"%c%c", CodeUnicode[I], 0);
        TrkCnt+= 4+ 2* strlen(CodeUnicode);
}
for( J= 0; J < Cnt; J++)
{       Evt= &EvtSerie[J];
        C0= Evt->Time-T;
#ifdef LOGFILE
        fprintf( LogFile,"%4d %04x %3d %02xch %02x %02x %c%c\n",
                J, Evt->Time, C0, Evt->Chn, Evt->Note, Evt->Velo, Evt->Lyr[0], Evt->Lyr[1]);
#endif
        T= Evt->Time;
        if( C0& 0x80)
        {       putc( 0x81, OutFile);
                ++TrkCnt;
        }
        putc( C0& 0x7f, OutFile);
        if( Evt->Lyr[0])        // It's lyric
        {       switch( Language)
                {   case LNG_CHINESE:
                        if( Evt->Lyr[1])
                        {       int     Pos;
                                if( Evt->Lyr[0]== 0x0d && Evt->Lyr[1]== 0x0a)
                                {       Evt->Lyr[0]= 0x0a;
                                        Evt->Lyr[1]= 0x00;
                                }
                                else    // Convert GBK to Unicode
                                {       Pos =(Evt->Lyr[0]-0x81)*192 + (Evt->Lyr[1]-0x40);
                                        //printf("%02x %02x\t%04x %5d\n", Evt->Lyr[1], Evt->Lyr[0], gbk2uni[Pos], Pos);
                                        if( Pos < 24192)
                                        {       Evt->Lyr[0]=( gbk2uni[Pos]& 0xff);
                                                Evt->Lyr[1]=( gbk2uni[Pos] >> 8);
                                        }
                                }
                        }
                        fprintf( OutFile,"%c%c%c%c%c", 0xff,0x05, 2, Evt->Lyr[0], Evt->Lyr[1]);
                        TrkCnt+= 6;
                        break;

                    default:
                        fprintf( OutFile,"%c%c%c%c", 0xff,0x05, 1, Evt->Lyr[0]);
                        TrkCnt+= 5;
                }
        }
        else
        {       putc( Evt->Chn, OutFile);
                putc( Evt->Note, OutFile);
                TrkCnt+= 3;
                if( (Evt->Chn& 0xf0)!= 0xc0 && (Evt->Chn& 0xf0)!= 0xd0)
                {       putc( Evt->Velo, OutFile);
                        ++TrkCnt;
                }
        }
}
fprintf( OutFile,"%c%c%c%c",0,0xff,0x2f,0);     // End of track
TrkCnt+= 4;
#ifdef LOGFILE
fprintf( LogFile,"-------------------- Track Length= %d\n", TrkCnt);
#endif
CurAddr= ftell( OutFile);
fseek( OutFile, TrkAddr, SEEK_SET);
TrkCnt= BE_LONG( TrkCnt);
fwrite( &TrkCnt, 1, sizeof( TrkCnt), OutFile);
fseek( OutFile, CurAddr, SEEK_SET);
delete EvtSerie;

#ifdef LOGFILE
fclose( LogFile);
#endif
//printf("%08x\n", Offset);
}
/*
//--------------------------------------------------------------------------
void	Song2File( int Offset)
{
	char	FName[64];
	FILE	*OutFile, *InFile;

	sprintf( FName,"%08x.mid", Offset);
	OutFile= fopen( FName, "wb");
	InFile= fopen( HotDog00, "rb");
//	ReadMidiDat( InFile, Offset, OutFile, 250);
	fclose( InFile);
	fclose( OutFile);
}

//--------------------------------------------------------------------------
void	ReadAllSongs()
{
int	Ret, Offset;
FILE	*AddrFile;
//int		OffsetAll[]={ 0x153b, 0xf9a3};

AddrFile= fopen( AddrFName, "r");
Ret= fscanf( AddrFile,"%x\n", &Offset);
while( Ret!= EOF)
{	Song2File( Offset);
	Ret= fscanf( AddrFile,"%x\n", &Offset);
}
fclose( AddrFile);
}
*/
//--------------------------------------------------------------------------
long	FindLyrStart(FILE *InFile, int Language)
{
unsigned short  C0,C1;
unsigned char    Buf[]={0,0,0,0,0,0};
int     Ret, Addr= 4;

fread( &C0, 2,1, InFile);
fread( &C1, 2,1, InFile);
do
{       if( Buf[1]==( C0& 0xff) && Buf[0]==( C0 >> 8)
                && Buf[5]==( C1& 0xff) && Buf[4]==( C1 >> 8))
                break;
        else
                fseek( InFile, Addr+1, SEEK_SET);
        Addr= ftell( InFile);
        Ret= fread( Buf, 1,6, InFile);
//        printf("%x %x\n", Buf[0],Buf[1]);
}
while( Ret);

if( !Ret)
{       printf("Unable to find the first 2 characters.\n");
        return Ret;
}

fseek( InFile, 2, SEEK_CUR);
for( int I= 0; I< 3 && Ret; I++)
{       HeadStr[I]="";
        while( Ret)
        {       Ret= fread( Buf, 1,4, InFile);
//                printf("%x %x\n", Buf[0],Buf[1]);
                if( Buf[0]== 0x0d && Buf[1]== 0x0a)
                        break;
                else
                {       switch( Language)
                        {   case LNG_CHINESE:
                            case LNG_ENGLISH:
                                HeadStr[I]+= Buf[I];
                                break;
                        }
                }
        }
        printf("%s\n", HeadStr[I].c_str());
}

return ftell( InFile);
}

