#include <stdio.h>
#include "hotdog00.h"
#include "gbk2uni.h"

int key2Ascii[] = {
  0x23, 0x00, 0x00, 0x00,
  0x30, 0x00, 0x00, 0x00,
  0x30, 0x00, 0x00, 0x00,
  0x30, 0x00, 0x00, 0x00,
  0x31, 0x00, 0x00, 0x00,

  0x0d, 0x0a, 0x00, 0x00,
  0x40, 0x00, 0x00, 0x00,
  0x40, 0x00, 0x00, 0x00,
  0x30, 0x00, 0x00, 0x00,
  0x30, 0x00, 0x00, 0x00,

  0x40, 0x00, 0x00, 0x00,
  0x31, 0x00, 0x00, 0x00,
  0x32, 0x00, 0x00, 0x00,
  0x0d, 0x0a, 0x00, 0x00,
  0x40, 0x00, 0x00, 0x00
};

int key2Dual[] = {
  0x23, 0x00, 0x00, 0x00,
  0x30, 0x00, 0x00, 0x00,
  0x30, 0x00, 0x00, 0x00,
  0x30, 0x00, 0x00, 0x00,
  0x31, 0x00, 0x00, 0x00,

  0x0d, 0x0a, 0x00, 0x00,
  0x40, 0x00, 0x00, 0x00,
  0x40, 0x00, 0x00, 0x00,
  0x30, 0x00, 0x00, 0x00,
  0x30, 0x00, 0x00, 0x00,

  0x40, 0x00, 0x00, 0x00,
//  0x31, 0x00, 0x00, 0x00,
  0x30, 0x00, 0x00, 0x00,
  0x32, 0x00, 0x00, 0x00,
  0x0d, 0x0a, 0x00, 0x00,
  0x40, 0x00, 0x00, 0x00
};
//=============================================================================
void ConvText( std::string *Str, char *OutStr, int LangCode)
{
int     Pos, I, J= 0;//, K;
//unsigned char    TmpStr[256];

if( LangCode== 0x03)    // Convert GBK to Unicode
{       for( I= 0; I < (int)Str->length(); I++)
        {       if( isprint((*Str)[I]))
                {       OutStr[J++]= (*Str)[I];
                        OutStr[J++]= 0;
                }
                else
                {       if( I < (int)Str->length()-1)
                        {   Pos =((unsigned char)(*Str)[I]-0x81)*192 + ((unsigned char)(*Str)[I+1]-0x40);
                            if( Pos < 24192)
                            {       OutStr[J++]=( gbk2uni[Pos]& 0xff);
                                    OutStr[J++]=( gbk2uni[Pos] >> 8);
//                                    printf("%02x %02x ", TmpStr[J-2],TmpStr[J-1]);
                                    ++I;
                            }
                            else
                                    OutStr[J++]=(*Str)[I];
                        }
                }
        }
/*        K= 0;
        for( int I= 0; I < J; I++)
                if( TmpStr[I]=='\'')
                {       OutStr[K++]='\'';
                        OutStr[K++]='\'';
                }
                else
                        OutStr[K++]= TmpStr[I];
        */
        OutStr[J]= OutStr[J+1]= 0;
}
else
{       for( I= 0; I < (int)Str->length(); I++)
                OutStr[I]=(*Str)[I];
        OutStr[I]= 0;
/*      K= 0;
        for( int I= 0; I < (int)Str->length(); I++)
                if( (*Str)[I]=='\'')
                {       OutStr[K++]='\'';
                        OutStr[K++]='\'';
                }
                else
                        OutStr[K++]=(*Str)[I];
        OutStr[K]= 0;
        */
}
}
//=============================================================================
unsigned long get32(FILE *f)
{
  unsigned long tmp, tmp2;

  tmp = 0;

  tmp2 = getc(f);
  tmp = (tmp << 8) | (tmp2 & 0x0FF);
  tmp2 = getc(f);
  tmp = (tmp << 8) | (tmp2 & 0x0FF);
  tmp2 = getc(f);
  tmp = (tmp << 8) | (tmp2 & 0x0FF);
  tmp2 = getc(f);
  tmp = (tmp << 8) | (tmp2 & 0x0FF);

  return tmp;
}
//=============================================================================
int getTableOfContents(FILE *inFile, unsigned long toc[TOC_LENGTH])
{
  int i;
  unsigned int tmp, tmp2;

  fseek(inFile, TOC_OFFSET, SEEK_SET);

  /*Read Table of Contents*/
  for (i=0; i<TOC_LENGTH; i++)
  {
    toc[i] = get32(inFile);
  }

  /*printf("Table of song entry tables:\n");*/

  /*Verify if addresses in table are valid*/
  /*TODO: Compare with length of file instead.*/
  for(i=0; i<TOC_LENGTH; i++)
  {
    tmp = fseek(inFile, toc[i], SEEK_SET);
    tmp2 = getc(inFile);

    /*printf("%4d: %8X %d %X\n", i, songEntryTable[i], tmp, tmp2);*/

    if(tmp != 0 | tmp2 == EOF)
    {
      break;
    }
  }

  /*printf("noSongEntryTables: %d\n\n", i);*/
  return i;
}


//=============================================================================
int getSongEntryTable(FILE *inFile, unsigned long offset, SongEntry songEntry[TOC_LENGTH])

{
  int noSongs, i;
  unsigned int tmp, tmp2, tmp3, tmp4;

  fseek(inFile, offset, SEEK_SET);

  for (i=0; i<TOC_LENGTH; i++)
  {
    songEntry[i].offset = get32(inFile);
    songEntry[i].length = 0;
    songEntry[i].midiOffset = 0;
  }
  for (i=0; i<TOC_LENGTH; i++)
  {
    songEntry[i].unknown = get32(inFile);
  }

  /*printf("CONTENT: %8X - %8X: Table of song entries %d\n", songEntryTable[j], songEntryTable[j]+0x800, j);
    printf("Table of song entries %d:\n", j);*/

  noSongs = 0;
  for(i=0; i<TOC_LENGTH; i++)
  {
    tmp = fseek(inFile, songEntry[i].offset, SEEK_SET);
    tmp2 = getc(inFile);

    /*printf("%4d: %8X ", i, songEntry[i]);*/

    if(tmp != 0 | tmp2 == EOF)
    {
      /*printf("\n");*/
      continue;
    }
    else
    {
      fseek(inFile, songEntry[i].offset, SEEK_SET);
      tmp = get32(inFile);
      tmp2 = get32(inFile);

      /* Check if this is a song entry */
      if ((tmp < 0x1FFFF) && (tmp > 0x100) && (tmp > tmp2) && (tmp2 < 0x3FFF) && (tmp2 > 0x10) && (songEntry[i].unknown != 0))
      {
	fseek(inFile, songEntry[i].offset+tmp2+14, SEEK_SET);

	tmp3 = getc(inFile);
	tmp4 = getc(inFile);
	/* One more check if this is a song entry ("00 00" in beginning of midi part) */
	if ((tmp3 == 0) || (tmp4 == 0))
        {
	  noSongs++;
	  songEntry[i].length = tmp;
	  songEntry[i].midiOffset = tmp2;
	}
	else
        {
	  /*printf("Not a song entry!\n");*/
	  continue;
	}
      }
      else
      {
	/*printf("Not a song entry.\n");*/
	continue;
      }
    }
  }
  return noSongs;
}

//=============================================================================
int ReadLyricDat(FILE *inFile, int offset, unsigned char Lpd[], int mode)
{
int     Tmp, KeyLen, Key[128], *Key2, Char4[4], LpdI= 0;
char    KeyChar;

switch( mode)
{   case ASCII_MODE:
        Key2= key2Ascii;
        break;

    case DUALBYTE_MODE:
        Key2= key2Dual;
        break;
}

/* Write the first 4 bytes to output file */
fseek(inFile, offset, SEEK_SET);
for( int I= 0; I < 4; I++)
{       Char4[I]= getc(inFile);
        if( Char4[I]== EOF)
                return 0;
        Lpd[ LpdI++]= Char4[I];
}

/* Determine the Key length */
// Read the beginning section (mask1)
for( int I= 0; I < 128; I++)
        Key[I]= getc(inFile);
// Try to find the end of mask1 applying 4 bytes from the mask
KeyLen= 0;
for( int I= 0; I < 70 && !KeyLen; I++)
        for( int J= 32; J < 128-3; J++)
//        {       printf("%d/%d %02x\n", I,J,Char4[1]);
                if( (Key[I] ^Key[J] ^Key2[I])== Char4[1]
                  && (Key[I+1] ^Key[J+1] ^Key2[I+1])== Char4[0]
                  && !(Key[I+2] ^Key[J+2] ^Key2[I+2])
                  && !(Key[I+3] ^Key[J+3] ^Key2[I+3]))
                {       KeyLen= J-I;
                        printf("Key length: %d\n", KeyLen);
                        break;
                }
//        }
if(!KeyLen)
        return 0;

/* Write key to output file */
for( int I= 0; I < KeyLen; I++)
    Lpd[ LpdI++]= Key[I];

/* Decode and write lyrics part to output file */
fseek(inFile, offset+ KeyLen+4, SEEK_SET);
int     J= KeyLen+4;

while (J < 0x200)
{       int c0,c1,c2,c3;
        for ( int K=0; K < KeyLen; K++)
        {       Tmp = getc(inFile);
      /* === For debugging ====
      switch (k%4)
      {   case 0:
              c0= tmp ^key[k] ^key2[k];
              printf("%3d k=0x%02x k2=0x%02x v=%02x o=%02x\n", k,key[k],key2[k],tmp, c0);
              break;

          case 1:
              c1= tmp ^key[k] ^key2[k];
              printf("%3d k=0x%02x k2=0x%02x v=%02x o=%02x\n", k,key[k],key2[k],tmp, c1);
              break;

          case 2:
              c2= tmp ^key[k] ^key2[k];
              printf("%3d k=0x%02x k2=0x%02x v=%02x o=%02x\n", k,key[k],key2[k],tmp, c2);
              break;

          case 3:
              c3= tmp ^key[k] ^key2[k];
              printf("%3d k=0x%02x k2=0x%02x v=%02x o=%02x\t[%c] %02x %02x\n", k,key[k],key2[k],tmp, c0,(char)c0, c3,c2);
              break;
      }
      */
            Tmp= Tmp ^Key[K] ^Key2[K];
/*
      if ((k%4) == 0)
      {
        tmp = (tmp ^ key2[k2]);
        k2 = (k2+1) % (keyLen/4);
      }
*/
        Lpd[ LpdI++]= Tmp;
        J++;
        if ( J >= 0x200)
                break;
        }
}
return KeyLen;
}

//=============================================================================
int ReadLyricDatOld(FILE *inFile, int offset, unsigned char Lpd[], int mode)
{
  int n, k, k2, tmp, LpdI= 0;
  int keyLen;
  int key[100];
  int *key2;

  if(mode==ASCII_MODE)
  {
    key2 = key2Ascii;
  }
  else if (mode==DUALBYTE_MODE)
  {
    key2 = key2Dual;
  }

  /* Write the first 4 bytes to output file */
  fseek(inFile, offset, SEEK_SET);
  for (n=0; n<4; n++)
  {
    tmp = getc(inFile);
    if (tmp == EOF)
    {
      return 0;
    }
    Lpd[ LpdI++]= tmp;
  }

  /* Determine the Key length */
  for(keyLen=0; keyLen<100; keyLen++)
  {
    key[keyLen] = getc(inFile);
    if ((keyLen>3) &&
        (key[keyLen-2]==key[1]) &&
        (key[keyLen-1]==key[2]) &&
        (key[keyLen]==key[3]))
    {
      keyLen -= 3;
      printf("Key length: %d\n", keyLen);
      break;
    }
  }
  if (keyLen>60)
  {
    printf("!");        // First attempt to determine Key length failed
    for(keyLen=8; keyLen<100; keyLen++)
    {
      if((key[keyLen-2]==key[5]) &&
         (key[keyLen-1]==key[6]) &&
         (key[keyLen]==key[7]))
      {
        keyLen -= 7;
        printf("Key length: %d\n", keyLen);
        break;
      }
    }
  }
  if (keyLen>60)
  {
//    printf("Failed to determine Key length\n");
    return 0;
  }

  /* Write key to output file */
  for(k=0; k<keyLen; k++)
  {
    Lpd[ LpdI++]= key[k];
  }

  /* Decode and write lyrics part to output file */
  fseek(inFile, offset+keyLen+4, SEEK_SET);
  n = keyLen+4;
  k2 = 0;
  while (n < 0x200)
  {
    int c0,c1,c2,c3;
    for (k=0; k<keyLen; k++)
    {
      tmp = getc(inFile);
      /* === For debugging ====*
      switch (k%4)
      {   case 0:
              c0= tmp ^key[k] ^key2[k];
              printf("%3d k=0x%02x k2=0x%02x v=%02x o=%02x\n", k,key[k],key2[k],tmp, c0);
              break;

          case 1:
              c1= tmp ^key[k] ^key2[k];
              printf("%3d k=0x%02x k2=0x%02x v=%02x o=%02x\n", k,key[k],key2[k],tmp, c1);
              break;

          case 2:
              c2= tmp ^key[k] ^key2[k];
              printf("%3d k=0x%02x k2=0x%02x v=%02x o=%02x\n", k,key[k],key2[k],tmp, c2);
              break;

          case 3:
              c3= tmp ^key[k] ^key2[k];
              printf("%3d k=0x%02x k2=0x%02x v=%02x o=%02x\t[%c] %02x %02x\n", k,key[k],key2[k],tmp, c0,(char)c0, c3,c2);
              break;
      }
  End debug    */
      tmp = tmp ^key[k] ^key2[k];
/*
      if ((k%4) == 0)
      {
        tmp = (tmp ^ key2[k2]);
        k2 = (k2+1) % (keyLen/4);
      }
*/
      Lpd[ LpdI++]= tmp;
      n++;
      if (n>= 0x200)
      {
        break;
      }
    }
  }
  return keyLen;
}

//=============================================================================
void ReadArtist( unsigned char Lpd[], char *Txt, int KeyLen, int Mode)
{
char    J= 0;

for( int I= 4 +KeyLen; I < 0x200-8; I++)
{       if( *((int*)&Lpd[I])=='@' && *((int*)&Lpd[I+4])=='@')
        {       I+= 8;
                while( I+1 < 0x200)
                {       if( Lpd[I]==0x0d && Lpd[I+1]==0x0a)
                                break;
                        Txt[J++]= Lpd[I];
                        if( Mode== DUALBYTE_MODE)
                                Txt[J++]= Lpd[I+1];
                        I+= 4;
                }
                Txt[J]= 0;
//                printf("%s\n", Txt);
                break;
        }
}
}

